dnl @synopsis AC_CXX_HAVE_STD_COMPARE 
dnl
dnl Define HAVE_STD_COMPARE if std::string::compare() has the right signature,
dnl as defined in ISO C++.
dnl 
dnl @version $Id: ac_cxx_have_std_compare.m4,v 1.1.1.1 2002/08/18 17:28:56 aeneas Exp $
dnl @author Stefan Farfeleder <e0026813@stud3.tuwien.ac.at>
dnl
AC_DEFUN([AC_CXX_HAVE_STD_COMPARE],
[AC_CACHE_CHECK(whether std::string::compare() has the correct signature,
ac_cv_cxx_have_std_compare,
[AC_REQUIRE([AC_CXX_NAMESPACES])
 AC_LANG_SAVE
 AC_LANG_CPLUSPLUS
 AC_TRY_COMPILE([
#include <string>
#ifdef HAVE_NAMESPACES
using namespace std;
#endif
 ],[
string s = "foobar";
return s.compare(0, 3, "foo");
 ], ac_cv_cxx_have_std_compare=yes, ac_cv_cxx_have_std_compare=no)
 AC_LANG_RESTORE
])
if test "$ac_cv_cxx_have_std_compare" = yes; then
 AC_DEFINE(HAVE_STD_COMPARE,,[define if std::string::compare() has the correct signature])
fi
])
