dnl check for ipv6 implementation
dnl taken from racoon
AC_DEFUN([AC_IPV6],
 [AC_ARG_ENABLE(ipv6,
  [  --enable-ipv6           Enable ipv6 support
  --disable-ipv6          Disable ipv6 support],
  [ if test "$enableval" = yes; then
     ac_cv_ipv6 = yes;
   fi],
  AC_CACHE_CHECK([for working ipv6 implementation], ac_cv_ipv6,
   [AC_TRY_COMPILE([
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
     ],[
  struct sockaddr_in6 s;
  int i = socket(AF_INET6, SOCK_STREAM, 0);
    ], ac_cv_ipv6=yes, ac_cv_ipv6=no)
   ]))
  if test "$ac_cv_ipv6" = yes; then
    AC_DEFINE(INET6,,[define if a working ipv6 implementation is available])
  fi
 ])
