/*
 *  $Id: panel.h,v 1.1.1.1 2002/08/18 17:28:54 aeneas Exp $
 *  Copyright (c) 2002, Dominik Schnitzer <dominik@schnitzer.at>
 *
 *  JFK - JFK Fucking Killerz, a massive multiplayer 2d shoot'em-up game
 *  http://relax.ath.cx/jfk/
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef JFK_PANEL_H
#define JFK_PANEL_H

#include "objects_c.h"
#include "output.h"

using namespace std;

namespace JFK
{
    namespace client
    {
        /* Hard-coded panel information */
        static const int    COORD_PANEL_WEAPONS[6][2] =
        {
            {427, 516}, {497, 516}, {547, 516},
            {427, 549}, {497, 549}, {547, 549}
        };
        
        class panel
        {
        public:
            /* Initialize the panel, load the pictures, set the default values
             *  output: pointer to the output plugin */
            panel(output *outp);
            ~panel();
            
            /* Draws the panel for the given person to the output surface */
            void                draw(person *pers);
            
        private:
            /* Draws the given number on the given position */
            void                draw_number(int x, int y, int nr);
        
            /* Private remember variables */
            output*             out;
            int                 last_health, last_ammo, last_weapon,
                                last_weaponcount;
            static const int    MAX_HEALTH = 100;

            /* The images */
            sprite*             player;
            sprite*             weapons;
            sprite*             number;
            sprite*             bar;
            sprite*             arrow;
        };
    }
}

#endif /* JFK_PANEL_H */
