/*
 * Copyright (c) 2002, Stefan Farfeleder <e0026813@stud3.tuwien.ac.at>
 * $Id: explosion_s.h,v 1.2 2002/09/17 17:15:05 stefan Exp $
 */
#ifndef JFK_EXPLOSION_S_H
#define JFK_EXPLOSION_S_H

#include <string>

#include "explosion.h"
#include "object_s.h"
#include "objhandle.h"

namespace JFK
{

namespace server
{

class explosion : public virtual JFK::server::object,
                  public virtual JFK::explosion
{
public:
    explosion(objhandle ioriginator);

    object*     clone() const { return new explosion(*this); }
    void        assign(const object* obj);

    std::string diffstring(const object* oldobj) const;

    void        move(double t);
    object*     action(double t);

    void        delegate_collision(object* obj) const;

    double      ttl;                /* time to live */
    objhandle   originator;         /* who caused the explosion */
};

}

}

#endif
