#ifndef JFK_ITEM_S_H
#define JFK_ITEM_S_H

#include <string>

#include "item.h"
#include "object_s.h"

namespace JFK
{

namespace server
{

class item : public virtual JFK::server::object, public virtual JFK::item
{
public:
    item(int itype);

    object*     clone() const { return new item(*this); }
    void        assign(const object* o);

    std::string diffstring(const object* objobj) const;
    void        fromstring(const std::string& s);

    object*     action(double);

    void        delegate_collision(object* obj) const;
    void        collide_with_person(const person*);

private:
    double      ttl;
};

}

}

#endif
