#ifndef JFK_OBSTACLE_S_H
#define JFK_OBSTACLE_S_H

#include <string>
#include <vector>

#include "object_s.h"
#include "obstacle.h"

namespace JFK
{

namespace server
{

struct point
{
    point(double ix, double iy) : x(ix), y(iy) {}
    double x, y;
};

class obstacle : public virtual JFK::server::object,
                 public virtual JFK::obstacle
{
public:
    obstacle(int itype);

    object*     clone() const { return new obstacle(*this); }
    void        assign(const object* o);

    std::string diffstring(const object* oldobj) const;
    void        fromstring(const std::string& s);

    object*     action(double) { return NULL; }

    void        delegate_collision(object* obj) const;

    std::vector<point>  p;
};

}

}

#endif
