#ifndef JFK_PERSON_S_H
#define JFK_PERSON_S_H

#include <string>

#include "bullet_s.h"
#include "explosion_s.h"
#include "item_s.h"
#include "object_s.h"
#include "obstacle_s.h"
#include "person.h"
#include "weapon_s.h"

namespace JFK
{

namespace server
{

class person : public virtual JFK::server::object, public virtual JFK::person
{
public:
    person(const std::string& iname);

    object*     clone() const { return new person(*this); }
    void        assign(const object* o);

    std::string diffstring(const object* oldobj) const;

    object*     action(double t);
    
    void        delegate_collision(object* obj) const;
    void        collide_with_bullet(const bullet* b);
    void        collide_with_explosion(const explosion* e);
    void        collide_with_item(const item* i);
    void        collide_with_obstacle(const obstacle* o);
    void        collide_with_person(const person* p);
    void        collide_with_weapon(const weapon* w);

    /* The more a player is drunk, the harder is it to move... */
    int         drunk;
    bool        firing;         /* received JFK::CMD_FIRE_START */
    double      reload_time;    /* time to next shot */
};

}

}

#endif
